<?php
/**
 * ExplorApp
 *
 * The application for the manipulation of files.
 *
 * @package	ExplorApp
 * @author	Yatsyshyn Mykhaylo Mykhaylovych
 * @copyright	Copyright (c) 2016. (http://explorApp.net/)
 * @license	http://explorApp.net/license
 * @link	http://explorApp.net/
 * @since	Version 1.0.0
 * @filesource
 */

include_once '../config.php';
include_once '../language/'.$language.'.php';

if(isset($_GET['path'])){
	$path = $_GET['path'];
} else {
	$path = $_POST['path'];
}

$path = $_SERVER['DOCUMENT_ROOT'].'/'.$pathfiles.'/'.$path;
$path = str_replace('//','/',$path);

//Display information of File
if(isset($_GET['info'])){
	$name = explode('/',$_POST['path']);
	$name = end($name);
	$ext = explode('.',$name);
	$ext = $extItem = end($ext);
	if($extItem == 'jpg' OR $extItem == 'jpeg' OR $extItem == 'png' OR $extItem == 'gif'){
		$image = '<img width="100%" style="max-height:200px;" src="'.$pathfiles.'/'.$_POST['path'].'">';
	} elseif($extItem == 'txt' OR $extItem ==  'css' OR $extItem ==  'sql' OR $extItem ==  'pdf'){
		$image = '<i class="fa fa-file-text" aria-hidden="true"></i>';
	} else {
		$image = '<i class="fa fa-file" aria-hidden="true"></i>';
	}

	echo '<div class="close" data-block="#info">[X]</div>';
	echo $image.'';
	echo '<div class="info">';
	echo $L['name'].': '.$name.'<br>';
	echo $L['extension'].': '.$ext.'<br>';
	echo $L['size'].': '.normal_size(filesize($path)).'<br>';
	echo $L['filetime'].': '.date('j.m.Y G:h',filemtime($path)).'<br>';
	echo $L['chmod'].': '.substr(sprintf('%o', fileperms($path)), -4);
	echo '</div>';
}

//Add new Folder
if(isset($_GET['addfolder'])){
	$name = $_POST['name'];
	$path = str_replace('//','/',$path.'/'.$name);
	if(strlen($name)==0){
		$errors = $LE['emptyname'];
	}
	if (ereg("[^a-zа-я0-9_][\s]",$name)){
		$errors = $LE['invalidsymbol'];
	} 
	if(is_dir($path)){
		$errors = $LE['isfile'];
	}
	if(!$errors){
		mkdir($path);
		echo $L['newfoldersave'];
	} else {
		echo $errors;
	}
}


//Upload file of input
if(isset($_GET['upload'])){
$allowed = $extension;

if(isset($_FILES['upl']) && $_FILES['upl']['error'] == 0){

	$extension = pathinfo($_FILES['upl']['name'], PATHINFO_EXTENSION);

	if(!in_array(strtolower($extension), $allowed)){
		echo '{"status":"error"}';
		exit;
	}
	$path = $_SERVER['DOCUMENT_ROOT'].'/'.$pathfiles.'/'.$_GET['p'];
	if(move_uploaded_file($_FILES['upl']['tmp_name'], $path.'/'.$_FILES['upl']['name'])){
		echo '{"status":"success"}';
		exit;
	}
}

echo '{"status":"error"}';
exit;
}


// delete files or folder

if(isset($_GET['delete'])){
	$type = $_POST['type'];
	echo $path;
	$c = chmod($path,0664);
	if($type == 'file'){
		$del = unlink($path);
	} elseif($type == 'folder'){
		function removeDirectory($dir) {
    		if ($objs = glob($dir."/*")) {
       			foreach($objs as $obj) {
       				$c = chmod($obj,0664);
        			is_dir($obj) ? removeDirectory($obj) : unlink($obj);
       			}
    		}
    	$r = rmdir($dir);
  		}
		removeDirectory($path);
	}
}


//rename file or directoyr

if(isset($_GET['rename'])){
	$name = $_POST['name'];
	$new = $_POST['newname'];
	var_dump($_POST);
	$r = rename($path.'/'.$name, $path.'/'.$new);
}

//Download 
if(isset($_GET['download'])){
    $file       = $path; 
    $file_info  = pathinfo($file);
    $file_ext   = $file_info['extension'];
    $file_name  = $file_info['basename'];
    $ignore_ext = $ignore_download; // игнорируемые файлы
    if(is_file($file) and in_array($file_ext, $ignore_ext)!=1 ){
        switch($file_ext){
            case "gif": $file_type="image/gif"; break;
            case "png": $file_type="image/png"; break;
            case "jpg": $file_type="image/jpg"; break;
            default: $file_type="application/force-download";
        }
         
        	header('Content-type: '.$file_type); 
        	header('Content-Disposition: attachment; filename=' . $file_name . ''); 
        	readfile('' . $file . ''); 
        	exit();
    	} else {
        	exit ("Неправильное имя файла !");
    	}
}
